<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPlanningPlaceItemResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfPlanningPlaceItemResult extends AbstractStructArrayBase
{
    /**
     * The PlanningPlaceItemResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PlanningPlaceItemResult[]
     */
    public $PlanningPlaceItemResult;
    /**
     * Constructor method for ArrayOfPlanningPlaceItemResult
     * @uses ArrayOfPlanningPlaceItemResult::setPlanningPlaceItemResult()
     * @param \StructType\PlanningPlaceItemResult[] $planningPlaceItemResult
     */
    public function __construct(array $planningPlaceItemResult = array())
    {
        $this
            ->setPlanningPlaceItemResult($planningPlaceItemResult);
    }
    /**
     * Get PlanningPlaceItemResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PlanningPlaceItemResult[]|null
     */
    public function getPlanningPlaceItemResult()
    {
        return isset($this->PlanningPlaceItemResult) ? $this->PlanningPlaceItemResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPlanningPlaceItemResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPlanningPlaceItemResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePlanningPlaceItemResultForArrayConstraintsFromSetPlanningPlaceItemResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPlanningPlaceItemResultPlanningPlaceItemResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfPlanningPlaceItemResultPlanningPlaceItemResultItem instanceof \StructType\PlanningPlaceItemResult) {
                $invalidValues[] = is_object($arrayOfPlanningPlaceItemResultPlanningPlaceItemResultItem) ? get_class($arrayOfPlanningPlaceItemResultPlanningPlaceItemResultItem) : sprintf('%s(%s)', gettype($arrayOfPlanningPlaceItemResultPlanningPlaceItemResultItem), var_export($arrayOfPlanningPlaceItemResultPlanningPlaceItemResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PlanningPlaceItemResult property can only contain items of type \StructType\PlanningPlaceItemResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PlanningPlaceItemResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PlanningPlaceItemResult[] $planningPlaceItemResult
     * @return \ArrayType\ArrayOfPlanningPlaceItemResult
     */
    public function setPlanningPlaceItemResult(array $planningPlaceItemResult = array())
    {
        // validation for constraint: array
        if ('' !== ($planningPlaceItemResultArrayErrorMessage = self::validatePlanningPlaceItemResultForArrayConstraintsFromSetPlanningPlaceItemResult($planningPlaceItemResult))) {
            throw new \InvalidArgumentException($planningPlaceItemResultArrayErrorMessage, __LINE__);
        }
        if (is_null($planningPlaceItemResult) || (is_array($planningPlaceItemResult) && empty($planningPlaceItemResult))) {
            unset($this->PlanningPlaceItemResult);
        } else {
            $this->PlanningPlaceItemResult = $planningPlaceItemResult;
        }
        return $this;
    }
    /**
     * Add item to PlanningPlaceItemResult value
     * @throws \InvalidArgumentException
     * @param \StructType\PlanningPlaceItemResult $item
     * @return \ArrayType\ArrayOfPlanningPlaceItemResult
     */
    public function addToPlanningPlaceItemResult(\StructType\PlanningPlaceItemResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PlanningPlaceItemResult) {
            throw new \InvalidArgumentException(sprintf('The PlanningPlaceItemResult property can only contain items of type \StructType\PlanningPlaceItemResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PlanningPlaceItemResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PlanningPlaceItemResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PlanningPlaceItemResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PlanningPlaceItemResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PlanningPlaceItemResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PlanningPlaceItemResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PlanningPlaceItemResult
     */
    public function getAttributeName()
    {
        return 'PlanningPlaceItemResult';
    }
}
